package cz.muni.fi.pb162.interfaces.devices;

/**
 * Rozhranie pre všetky zariadenia, pri ktorých je možna výmena batérie
 * Triedy ktoré implementujú toto rozhranie budú musieť implementovať metódy replace battery, discharge a batteryLevel
 */
public interface BatteryReplaceable {

    /**
     * Odoberie dané množstvo perecent z momentálneho stavu batérie
     * Stav batérie nemôže byť nižší ako 0%
     * V príapde záporného čisla sa na štandardný chybový výstup vypíše chybová hláška
     * @param percent počet percent, ktorý sa odráta od momentálneho stavu batérie
     */
    void discharge(int percent);

    /**
     * Výmena baterie v zariadeni pre zjednodušenie zmeni momentalny stav baterie na 100%
     */
    void replaceBattery();

    /**
     * Metóda vráti momentálny stav batérie v percentách
     * @return momentálny stav batérie v percentách
     */
    int getBatteryLevel();
}
