package cz.muni.fi.pb162.interfaces.devices;

/**
 * Rozhranie pre všetky zariadenia, ktoré je možné vybíjať a opätovne nabijat
 * Všetky triedy, ktoré dedia toto rozhranie musia mať implementované metódy charege, discharge a getBatteryLevel
 */
public interface Chargeable {

    /**
     * Pridá dané množstvo percent k momentálnemu stavu batérie
     * Stav batérie nemôže byť vyšší ako 100%
     * V príapde záporného čisla sa na štandardný chybový výstup vypíše chybová hláška
     * @param percent počet percent, ktorý sa pripočíta k momentálnemu stavu batérie
     */
    void charge(int percent);

    /**
     * Odoberie dané množstvo perecent z momentálneho stavu batérie
     * Stav batérie nemôže byť nižší ako 0%
     * V príapde záporného čisla sa na štandardný chybový výstup vypíše chybová hláška
     * @param percent počet percent, ktorý sa odráta od momentálneho stavu batérie
     */
    void discharge(int percent);

    /**
     * Metóda vráti momentálny stav batérie v percentách
     * @return momentálny stav batérie v percentách
     */
    int getBatteryLevel();
}
