package cz.muni.fi.pb162.interfaces.devices;

/**
 * Rozhranie pre všetky zariadenia, ktoré umožňujú fast charging
 * Podobne ako triedy aj u rozhrani je možné využiť dedičnosť (viac o dedičnosťi sa dozviete v príprave na búduci týžden)
 * Triedy, ktoré implementujú toto rozhranie budú musieť implementovať všetky metódy rozhrania Chargeable a metódu
 * fastCharge()
 */
public interface FastChargeable extends Chargeable {

    /**
     * Rychlonabíjanie bude v našom ponímane implementované tak, že k momentálnemu stavu baterie sa pripočíta dvojnásobok
     * hodnoty danej uzivatelom
     * V prípade záporného čísla sa na štandardný chybový výstup vypíše chybová hláška, stav baterie sa nezmeni
     * Nabitie batérie nemôže byť viac ako 100%
     * @param percent počet persent o koľko sa má navýšiť stav batérie
     */
    void fastCharge(int percent);
}
