package cz.muni.fi.pb162.interfaces.devices;

// trieda môže implementovať viacero rozhraní naraz
public class Smartphone implements Device, FastChargeable {

    private String mark;
    private String model;
    private int batteryLevel = 40;

    public Smartphone(String mark, String model) {
        this.mark = mark;
        this.model = model;
    }

    @Override
    public String getMark() {
        return mark;
    }

    @Override
    public String getModel() {
        return model;
    }

    @Override
    public int getBatteryLevel() {
        return batteryLevel;
    }

    @Override
    public void fastCharge(int percent) {
        if (!validate(percent, "charged")) {
            return;
        }
        if (2*percent + batteryLevel > 100) {
            batteryLevel = 100;
            return;
        }
        batteryLevel += 2*percent;
    }

    @Override
    public void charge(int percent) {
        if (!validate(percent, "charged")) {
            return;
        }
        if (percent + batteryLevel > 100) {
            batteryLevel = 100;
            return;
        }
        batteryLevel += percent;
    }

    @Override
    public void discharge(int percent) {
        if (!validate(percent, "discharged")) {
            return;
        }
        if (batteryLevel - percent < 0) {
            batteryLevel = 0;
            return;
        }
        batteryLevel -= percent;
    }

    private boolean validate(int percent, String message) {
        if (percent < 0) {
            System.err.println("Device cannot be " + message + " negative percent of battery life!");
            return false;
        }
        return true;
    }

}
