package cz.muni.fi.pb162.calculator;


import cz.muni.fi.pb162.testing.Calculator;
import org.junit.Assert;
import org.junit.Test;
import org.junit.Before;

/**
 * V tejto triede si vytvorime jednotkové (unit) testy pre triedu Calculator
 * Testovacia trieda podobne ako klasická môže obsahovať attribúty
 * Jednotlive testy sú metódy triedy označené anotáciou @Test
 * Jeden test by mal vždy testovat iba jednu funkcionalitu
 */
public class CalculatorTest {

    public final static double MAX_ERROR = 0.00001;

    @Test
    public void additionTest() {
        Assert.assertEquals(7, Calculator.add(3, 4), MAX_ERROR);
    }

    @Test
    public void subtractionTest() {
        Assert.assertEquals(-2, Calculator.subtract(5, 7), MAX_ERROR);
    }

    @Test
    public void divisionTest() {
        Assert.assertEquals(2.5, Calculator.division(5, 2), MAX_ERROR);
    }

    @Test
    public void multiplicationTest() {
        Assert.assertEquals(12, Calculator.multiply(3, 4), MAX_ERROR);
    }

    /**
     * Ak očakávame, že test vyhodí výnimku na overenie či bola skutočne vyhodená použijeme
     * expected = <výnimka>.class
     * V prípade, že výnimka nebola vyhodená test skončí neúspešne
     */
    @Test(expected = ArithmeticException.class)
    public void divisionByZeroTest() {
        Calculator.division(5, 0);
    }

    /**
     * Testujeme viacero funkcionalit. V pripade, že nastane chyba neviem, ktorá metóda je chybne implementovaná
     */
    @Test
    public void wrongExampleTest() {
        double result = Calculator.subtract(6, 2); // 4
        result = Calculator.multiply(result, 8); // 32
        result = Calculator.division(48, result); // 1,5
        result = Calculator.subtract(result, 5); //-3.5

        Assert.assertEquals(-3.5, result, MAX_ERROR);
    }
}
